import BTreesModule

t11 = E1
t12 = B1 1 (B1 2 E1 E1) (B1 3 E1 E1)
t13 = B1 1 (B1 2 E1 (B1 3 E1 E1)) (B1 4 (B1 5 E1 E1) (B1 6 (B1 7 E1 E1) E1))

t21 = L2 1
t22 = B2 (L2 1) (L2 2)
t23 = B2 (L2 1) (B2 (L2 2) (B2 (L2 3) (L2 4)))

t31 = L3 1
t32 = B3 1 (L3 2) (L3 3)
t33 = B3 1 (L3 2) (B3 3 (L3 4) (B3 5 (L3 6) (L3 7)))

t41 = L4 1
t42 = B4 "cat" (L4 2) (L4 3)
t43 = B4 "cat" (L4 2) (B4 "dog" (L4 4) (B4 "can" (L4 6) (L4 7)))

t51 = Tip5
t52 = B5 Tip5 Tip5
t53 = L5 1
t54 = B5 (L5 1) (L5 2)
t55 = B5 (L5 1) (B5 (L5 2) (B5 (L5 3) (L5 4)))
t56 = B5 Tip5 (L5 1)
t57 = B5 Tip5 (B5 (L5 1) (B5 (L5 2) Tip5))


-- sum the numbers in a binary tree
sumbt1 :: (Num a) => BTree1 a -> a
sumbt1 E1 = 0
sumbt1 (B1 n t1 t2) = n + (sumbt1 t1) + (sumbt1 t2)

sumbt2 :: (Num a) => BTree2 a -> a
sumbt2 (L2 n) = n
sumbt2 (B2 t1 t2) = (sumbt2 t1) + (sumbt2 t2)

sumbt3 :: (Num a) => BTree3 a -> a
sumbt3 (L3 n) = n
sumbt3 (B3 n t1 t2) = n + (sumbt3 t1) + (sumbt3 t2)

--sumbt4 :: (Num a) => BTree4 a b -> a
--sumbt5 :: (Num a) => BTree5 a -> a


-- traverse a binary tree (convert it to a list)
-- pre-order traversal
traverse1B :: BTree1 a -> [a]
traverse1B E1 = []
traverse1B (B1 n t1 t2) = [n] ++ (traverse1B t1) ++ (traverse1B t2)

-- in-order traversal
traverse1I :: BTree1 a -> [a]
traverse1I E1 = []
traverse1I (B1 n t1 t2) = (traverse1I t1) ++ [n] ++ (traverse1I t2)

 -- post-order traversal
traverse1A :: BTree1 a -> [a]
traverse1A E1 = []
traverse1A (B1 n t1 t2) = (traverse1A t1) ++ (traverse1A t2) ++ [n]


-- BTree2 has only one kind of traversal.
traverse2 :: BTree2 a -> [a]
traverse2 (L2 n) = [n]
traverse2 (B2 t1 t2) = (traverse2 t1) ++ (traverse2 t2)


--traverse3B :: BTree1 a -> [a] -- pre-order
--traverse3I :: BTree1 a -> [a] -- in-order
--traverse3A :: BTree1 a -> [a] -- post-order

--traverse4B :: BTree4 a b -> [Either a b] -- pre-order
--traverse4I :: BTree4 a b -> [Either a b] -- in-order
--traverse4A :: BTree4 a b -> [Either a b] -- post-order

--traverse5B :: BTree5 a -> [a] -- pre-order
--traverse5I :: BTree5 a -> [a] -- in-order
--traverse5A :: BTree5 a -> [a] -- post-order

--traverse6B :: BTree6 a -> [a] -- pre-order
--traverse6I :: BTree6 a -> [a] -- in-order
--traverse6A :: BTree6 a -> [a] -- post-order



-- find maximum of a non-empty list
maxList :: (Ord a) => [a] -> a
maxList [x] = x  -- stop the recursion on a one item list
maxList (x:xs) = max x (maxList xs)

-- find maximum of a non-empty BTree1
maxBT1 :: (Ord a) => BTree1 a -> a
maxBT1 (B1 n E1 E1) = n
maxBT1 (B1 n t1 E1) = max n (maxBT1 t1)
maxBT1 (B1 n E1 t1) = max n (maxBT1 t1)
maxBT1 (B1 n t1 t2) = max n (max (maxBT1 t1) (maxBT1 t2))

-- find maximum of a BTree2 (which can never be empty)
maxBT2 :: (Ord a) => BTree2 a -> a
maxBT2 (L2 n) = n
maxBT2 (B2 t1 t2) = max (maxBT2 t1) (maxBT2 t2)

-- find maximum of a BTree3 (which can never be empty)
maxBT3 :: (Ord a) => BTree3 a -> a
maxBT3 (L3 n) = n
maxBT3 (B3 n t1 t2) = max n (max (maxBT3 t1) (maxBT3 t2))


--maxBT4L :: (Ord a) => BTree4 a b -> a
--maxBT4B :: (Ord b) => BTree4 a b -> b
--maxBT5 :: (Ord a) => BTree5 a -> Maybe a -- this one is tricky

