/*
   Here is a naive way to define a linked list in Java.
   The main problem here is that an "empty list" is
   denoted by a null reference,
      List myList = null; // an empty list?
   Using null to denote an empty list will cause all
   kinds of problems. For example, you can't compute
   the length of an empty list,
      int n = myList.length();
   because you get a null pointer exception.
*/
class List
{
   public int x;
   public List next;

   public List(int x, List next)
   {
      this.x = x;
      this.next = next;
   }

   public int length1() // this length method can never return 0
   {                    // and it cannot be called on an "empty" list
      if (null == next)
         return 1;
      else
         return 1 + next.length1();
   }

   public static int length2(List list) // this has to be static to work properly
   {
      if (null == list)
         return 0;
      else
         return 1 + length2(list.next);
   }

   public static void main(String[] args)
   {
      List x = new List(3, new List(2, new List(1, null)));
      List y = null;  // an "empty" list?

      System.out.println( x.length1() );  // prints 3
      System.out.println( length2(x) );   // prints 3
      System.out.println( length2(y) );   // prints 0
      System.out.println( y.length1() );  // compiles but does not run!
   }
}
