
-- Notice how similar the structure is for Maybe, List and BTree.
-- Each one is structured as an "empty" case OR a "non-empty" case.

-- As algebraic data types, 
--   the structure of Maybe is "empty OR data",
--   the structure of List  is "empty OR (data AND List)",
--   the structure of BTree is "empty OR (data AND BTree AND BTree)".

data Maybe a = Nothing
             | Just a

data List a = Empty
            | Cons a (List a)

data BTree a = Nil
             | Branch a (BTree a) (BTree a)
